#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <math.h>
#include <string.h>
#include <algorithm>

#include "structures.h"

// unwatch a literal.  It might seem smarter to just pop the top
// clause and drop it in the current slot, but this leads to a small
// performance degradation, presumably because of the instability in
// the resulting clause ordering.

void solver::lit_unwatches_clause(literal l, const clause &c)
{
  vector<clause_id> &watches = watched[index(l)];
  vector<clause_id>::iterator i = find(watches.begin(),watches.end(),c.id);
  copy(i + 1,watches.end(),i);
  watches.pop_back();
}

void solver::initialize_watchers()
{
  for (size_t i = 0 ; i < original_clauses.size() ; ++i)
    initialize_watchers(original_clauses[i]);
}

void solver::initialize_watchers(const clause &c)
{
  assert(c.size() > 1);
  lit_watches_clause(c[0],c);
  lit_watches_clause(c[1],c);
}
